/*
 * WSO2 User Management Remote API
 * This document specifies a **RESTful API** for WSO2 **User Management**.  It is written with [swagger 2](http://swagger.io/). 
 *
 * OpenAPI spec version: v1.0
 * Contact: architecture@wso2.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.carbon.apimgt.rest.integration.tests.scim.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;
import org.wso2.carbon.apimgt.rest.integration.tests.scim.model.Group;

/**
 * GroupList
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-04-17T00:32:36.849+05:30")
public class GroupList {
  @JsonProperty("startIndex")
  private Integer startIndex = null;

  @JsonProperty("itemsPerPage")
  private Integer itemsPerPage = null;

  @JsonProperty("totalResults")
  private Integer totalResults = null;

  @JsonProperty("schemas")
  private List<String> schemas = null;

  @JsonProperty("Resources")
  private List<Group> resources = null;

  public GroupList startIndex(Integer startIndex) {
    this.startIndex = startIndex;
    return this;
  }

   /**
   * Number of Groups returned. 
   * @return startIndex
  **/
  @ApiModelProperty(example = "1", value = "Number of Groups returned. ")
  public Integer getStartIndex() {
    return startIndex;
  }

  public void setStartIndex(Integer startIndex) {
    this.startIndex = startIndex;
  }

  public GroupList itemsPerPage(Integer itemsPerPage) {
    this.itemsPerPage = itemsPerPage;
    return this;
  }

   /**
   * Items for page 
   * @return itemsPerPage
  **/
  @ApiModelProperty(value = "Items for page ")
  public Integer getItemsPerPage() {
    return itemsPerPage;
  }

  public void setItemsPerPage(Integer itemsPerPage) {
    this.itemsPerPage = itemsPerPage;
  }

  public GroupList totalResults(Integer totalResults) {
    this.totalResults = totalResults;
    return this;
  }

   /**
   * Total result count 
   * @return totalResults
  **/
  @ApiModelProperty(value = "Total result count ")
  public Integer getTotalResults() {
    return totalResults;
  }

  public void setTotalResults(Integer totalResults) {
    this.totalResults = totalResults;
  }

  public GroupList schemas(List<String> schemas) {
    this.schemas = schemas;
    return this;
  }

  public GroupList addSchemasItem(String schemasItem) {
    if (this.schemas == null) {
      this.schemas = new ArrayList<String>();
    }
    this.schemas.add(schemasItem);
    return this;
  }

   /**
   * Get schemas
   * @return schemas
  **/
  @ApiModelProperty(value = "")
  public List<String> getSchemas() {
    return schemas;
  }

  public void setSchemas(List<String> schemas) {
    this.schemas = schemas;
  }

  public GroupList resources(List<Group> resources) {
    this.resources = resources;
    return this;
  }

  public GroupList addResourcesItem(Group resourcesItem) {
    if (this.resources == null) {
      this.resources = new ArrayList<Group>();
    }
    this.resources.add(resourcesItem);
    return this;
  }

   /**
   * Get resources
   * @return resources
  **/
  @ApiModelProperty(value = "")
  public List<Group> getResources() {
    return resources;
  }

  public void setResources(List<Group> resources) {
    this.resources = resources;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GroupList groupList = (GroupList) o;
    return Objects.equals(this.startIndex, groupList.startIndex) &&
        Objects.equals(this.itemsPerPage, groupList.itemsPerPage) &&
        Objects.equals(this.totalResults, groupList.totalResults) &&
        Objects.equals(this.schemas, groupList.schemas) &&
        Objects.equals(this.resources, groupList.resources);
  }

  @Override
  public int hashCode() {
    return Objects.hash(startIndex, itemsPerPage, totalResults, schemas, resources);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GroupList {\n");
    
    sb.append("    startIndex: ").append(toIndentedString(startIndex)).append("\n");
    sb.append("    itemsPerPage: ").append(toIndentedString(itemsPerPage)).append("\n");
    sb.append("    totalResults: ").append(toIndentedString(totalResults)).append("\n");
    sb.append("    schemas: ").append(toIndentedString(schemas)).append("\n");
    sb.append("    resources: ").append(toIndentedString(resources)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

